//---------------------------------------------------------------------------
// Copyright (c) 2000 Andreas Huennebeck
//
// $Source: /home/ah/CvsTree/daten/src/audio/TestLinuxKernelPcm.c,v $
// $Id: TestLinuxKernelPcm.c,v 1.1 2000/02/21 23:33:31 ah Exp $
//
// Description: 
//
//---------------------------------------------------------------------------

// --- forward declarations ---

// --- necessary includes ---

#include <AH/Audio/LinuxKernelMix.h>

#include <unistd.h>
#include <iostream>
#include <AH/Error/Basic.h>
#include <AH/Error/Sys.h>

USING_NAMESPACE(AH)

// --- types and classes ---

int main(int argc, char* argv[])
{
    unsigned char* buf = 0;
    try
    {
	AudioLinuxKernelMix mix;

	// open device:
	mix.openDev(SystemDevice::RW);
	cout << "Active Record Input: " << mix.getRecordInput() << endl;
	cout << "Master Volume Level: " << mix.getMasterVolume() << endl;

	vector<string> subdevs;
	mix.getAllSubDev(subdevs);
	for (unsigned int i = 0; i < subdevs.size(); i++)
	{
	    cout << "supports subdevice: " << subdevs[i] << endl;
	} 

	for (int vol = 50; vol <= 100; vol += 10)
	{
	    mix.setMasterVolume(vol);
	    cout << "Master Volume Level: " << mix.getMasterVolume() << endl;
	    sleep(1);
	}
	// get default settings:
    }
    catch(ErrorBasic& err)
    {
	if (buf) delete[] buf;
	cerr << "Error: " << err.getMsg() << endl;
	return 1;
    }
    catch(...)
    {
	if (buf) delete[] buf;
	cerr << "Error: unknown exception" << endl;
	return 1;
    }
    return 0;
}

// *********************************************************************
// *			     E N D   O F   F I L E                     *
// *********************************************************************
