//---------------------------------------------------------------------------
// Copyright 2000 Andreas Huennebeck
//
// Licensed under the terms of the GNU General Public License.
// ABSOLUTELY NO WARRANTY. See the file 'COPYING' in this distribution.
//
// $Source: /home/ah/CvsTree/daten/src/ft/PlainOutput.h,v $
// $Id: PlainOutput.h,v 1.5 2002/11/14 21:58:20 ah Exp $ 
//
//---------------------------------------------------------------------------

#ifndef AH_FT_PLAIN_OUTPUT
#define AH_FT_PLAIN_OUTPUT

const char FtPlainOutput_CVSIDd[] = "$Id: PlainOutput.h,v 1.5 2002/11/14 21:58:20 ah Exp $ (c) 2002 Andreas Huennebeck";

// --- necessary includes ---
#include <AH/Config/Platform.h> // always the first include
USING_NAMESPACE(AH)

#include <stdio.h>

class Cplx;

// --- constants ---

// --- classes ---

class PlainOutput
{
 public:
    PlainOutput(FILE* fpo, bool is_linear, unsigned int inum, 
		unsigned int onum, double f_max,
		double db_add, unsigned int debug = 0);
    virtual ~PlainOutput() {}
    virtual void print(double f, const Cplx& val);
    void done();
 protected:
    virtual void printValues(double f, double db, double phi, double dbmax,
			     double phimax, double dbmin, double phimin);
    double get_dB(const Cplx& val);

    FILE* fp;
    bool linear;
    unsigned int inum;
    unsigned int onum;
    unsigned int cnt;
    unsigned int ocnt;
    unsigned int debon;
    double add_db;
    double sum_db;
    double sum_phi;
    double max_db;
    double max_phi;
    double min_db;
    double min_phi;
    double f_min;
    double f_next;
    double f1;
    double f2;
    double delta;
};

#endif // !AH_FT_PLAIN_OUTPUT
// --- end of file ---
