//---------------------------------------------------------------------------
// Copyright 2000 Andreas Huennebeck
//
// Licensed under the terms of the GNU General Public License.
// ABSOLUTELY NO WARRANTY. See the file 'COPYING' in this distribution.
//
// $Source: /home/ah/CvsTree/daten/src/ft/RiaaOutput.c,v $
// $Id: RiaaOutput.c,v 1.1 2002/11/01 18:16:38 ah Exp $ 
//
// Description: print information about specified wav file
//
//---------------------------------------------------------------------------

static const char rcsid[] = "$Id: RiaaOutput.c,v 1.1 2002/11/01 18:16:38 ah Exp $ (c) 2000 Andreas Huennebeck";

// --- necessary includes ---
#include <AH/Config/Platform.h> // always the first include

#include <AH/Etech/Riaa.h>
#include <AH/Etech/Algo.h>
USING_NAMESPACE(AH)
#include "RiaaOutput.h"

#include <stdlib.h>
#include <math.h>

// --- local constants ---

// --- local classes ---

RiaaOutput::RiaaOutput(FILE* fpo, unsigned int in_size, 
		       unsigned int out_size, double f_max, unsigned int debug)
    : PlainOutput(fpo, in_size, out_size, f_max, debug)
{
}

void RiaaOutput::printValues(double f, double db, double phi)
{
    Cplx pre(RiaaPreEmphasis(f));
    double db_pre = inVdB(abs(pre));
    double phi_pre = inDeg(arg(pre));
    fprintf(fp, "%f %f %f %f %f\n", f, db + db_pre, phi + phi_pre,
	    db_pre, phi_pre);
}

// --- end of file ---
