//---------------------------------------------------------------------------
// Copyright 2002 Andreas Huennebeck
//
// Licensed under the terms of the GNU General Public License.
// ABSOLUTELY NO WARRANTY. See the file 'COPYING' in this distribution.
//
// $Source: /home/ah/CvsTree/daten/src/gensig/SigBase.h,v $
// $Id: SigBase.h,v 1.3 2004/04/21 20:41:05 ah Exp $ 
//
// Description: print information about specified wav file
//
//---------------------------------------------------------------------------

#ifndef SIGNAL_BASE_H
#define SIGNAL_BASE_H

// --- necessary includes ---

#include <iostream>
#include <AH/Config/Platform.h> // always the first include
USING_NAMESPACE(AH)

// --- forward declarations ---

// --- types and classes ---

class SignalBase
{
 public:
    SignalBase(double amplitude, unsigned int samplerate,
	       unsigned int debug = 0)
	: maxAmpl(amplitude), sr(samplerate), debon(debug)
    {
	if (debon > 1) std::cerr << "SignalBase: maxAmpl=" << maxAmpl 
				 << ", sr=" << sr  << std::endl;
    }
    virtual ~SignalBase() {}

    virtual void addSignal(double* data, unsigned int num) = 0;

 protected:
    double maxAmpl;
    unsigned int sr;
    unsigned int debon;
};

#endif // !SIGNAL_BASE_H
// --- end of file ---
