//---------------------------------------------------------------------------
// Copyright 2002 Andreas Huennebeck
//
// Licensed under the terms of the GNU General Public License.
// ABSOLUTELY NO WARRANTY. See the file 'COPYING' in this distribution.
//
// $Source: /home/ah/CvsTree/daten/src/gensig/SigColNoise.h,v $
// $Id: SigColNoise.h,v 1.1 2002/12/15 16:42:44 ah Exp $ 
//
// Description: print information about specified wav file
//
//---------------------------------------------------------------------------

#ifndef SIGNAL_COLORED_NOISE_H
#define SIGNAL_COLORED_NOISE_H

// --- necessary includes ---
#include <AH/Config/Platform.h> // always the first include
USING_NAMESPACE(AH)
#include "SigBase.h"

#include <values.h> 

// --- forward declarations ---

// --- types and classes ---

class SignalColoredNoise: public SignalBase
{
 public:
    SignalColoredNoise(double amplitude, unsigned int samplerate, 
		     unsigned int debug = 0);
    virtual ~SignalColoredNoise() {}

    virtual void addSignal(double* data, unsigned int num);

 protected:
    virtual void shapeNoiseSpectrum(double* sdata, unsigned int num);
    virtual double getRealFactor(unsigned int i) = 0;
    virtual double getImagFactor(unsigned int i) = 0;
};

#endif // !SIGNAL_COLORED_NOISE_H
// --- end of file ---
