//---------------------------------------------------------------------------
// Copyright 2000 Andreas Huennebeck
//
// Licensed under the terms of the GNU General Public License.
// ABSOLUTELY NO WARRANTY. See the file 'COPYING' in this distribution.
//
// $Source: /home/ah/CvsTree/daten/src/gensig/SigLsb.c,v $
// $Id: SigLsb.c,v 1.1 2002/12/17 23:41:52 ah Exp $ 
//
// Description: print information about specified wav file
//
//---------------------------------------------------------------------------

const char sweep_CVSID[] = "$Id: SigLsb.c,v 1.1 2002/12/17 23:41:52 ah Exp $ (c) 2002 Andreas Huennebeck";

// --- necessary includes ---
#include <AH/Config/Platform.h> // always the first include
USING_NAMESPACE(AH)
#include "SigLsb.h"

#include <math.h>
USING_NAMESPACE(std)

#include <AH/Error/Sys.h>
#include <AH/Error/Intern.h>
USING_NAMESPACE(AH)


// --- local constants ---

// --- local data ---

// --- local classes ---

// --- local functions ---

// --- global functions ---

void SignalLsb::addSignal
(
    double* data,
    unsigned int num
)
{
    if (!data) throw ErrorInternNullPtrArg("SignalLsb::addSignal");
    if (!num) throw ErrorInternBadArg("SignalLsb::addSignal");

    const unsigned int delta = (unsigned int)(sr / freq);
    const double add = 0.1; 
    double lsb_on = (double)((0x1 << bits) - 1);
    if (debon)
	cerr << "lsb_on=" << lsb_on + add << ", off=" << add << endl;
    for (unsigned int i = 0; i < num; ++i)
    {
	if ((i % delta) < delta/2) data[i] += lsb_on + add;
	else                       data[i] += add;
    }
}

// --- end of file ---











