//---------------------------------------------------------------------------
// Copyright 2000 Andreas Huennebeck
//
// Licensed under the terms of the GNU General Public License.
// ABSOLUTELY NO WARRANTY. See the file 'COPYING' in this distribution.
//
// $Source: /home/ah/CvsTree/daten/src/gensig/SigMsb.c,v $
// $Id: SigMsb.c,v 1.1 2002/12/17 23:41:52 ah Exp $ 
//
// Description: print information about specified wav file
//
//---------------------------------------------------------------------------

const char sweep_CVSID[] = "$Id: SigMsb.c,v 1.1 2002/12/17 23:41:52 ah Exp $ (c) 2002 Andreas Huennebeck";

// --- necessary includes ---
#include <AH/Config/Platform.h> // always the first include
USING_NAMESPACE(AH)
#include "SigMsb.h"

#include <math.h>
USING_NAMESPACE(std)

#include <AH/Error/Sys.h>
#include <AH/Error/Intern.h>
USING_NAMESPACE(AH)


// --- local constants ---

// --- local data ---

// --- local classes ---

// --- local functions ---

// --- global functions ---

void SignalMsb::addSignal
(
    double* data,
    unsigned int num
)
{
    if (!data) throw ErrorInternNullPtrArg("SignalMsb::addSignal");
    if (!num) throw ErrorInternBadArg("SignalMsb::addSignal");

    const unsigned int delta = (unsigned int)(sr / freq);
    const double add = -0.5; 
    if (debon > 1)
	cerr << "msb_on=" << -1.0 + add << ", off=" << add << endl;
    for (unsigned int i = 0; i < num; ++i)
    {
	if ((i % delta) < delta/2) data[i] += -1.0 + add;
	else                       data[i] += add;
    }
//	    int32 val = (int32)(data[i] + 0.5);
}

// --- end of file ---











