//---------------------------------------------------------------------------
// Copyright 2000 Andreas Huennebeck
//
// Licensed under the terms of the GNU General Public License.
// ABSOLUTELY NO WARRANTY. See the file 'COPYING' in this distribution.
//
// $Source: /home/ah/CvsTree/daten/src/gensig/SigPinkNoiseRange.c,v $
// $Id: SigPinkNoiseRange.c,v 1.2 2004/04/21 20:41:05 ah Exp $ 
//
// Description: print information about specified wav file
//
//---------------------------------------------------------------------------

const char sweep_CVSID[] = "$Id: SigPinkNoiseRange.c,v 1.2 2004/04/21 20:41:05 ah Exp $ (c) 2002 Andreas Huennebeck";

// --- necessary includes ---
#include <AH/Config/Platform.h> // always the first include
USING_NAMESPACE(AH)
#include "SigPinkNoiseRange.h"

#include <math.h>
#include <drfftw.h> 
USING_NAMESPACE(std)

#include <AH/Etech/Types.h> // always the first include
#include <AH/Error/Sys.h>
#include <AH/Error/Intern.h>
#include <AH/Math/Ft/Wisdom.h>
USING_NAMESPACE(AH)

#include "SigPinkNoise.h"
#include "Util.h"

// --- local constants ---

// --- local data ---

// --- local classes ---

// --- local functions ---

// --- global functions ---

SignalPinkNoiseRange::SignalPinkNoiseRange
(
    double fbegin, double fend, double amplitude,
    unsigned int samplerate, unsigned int debug
)
    : SignalColoredNoise(amplitude, samplerate, debug),
      f1(fbegin), f2(fend)
{
    if (debon > 1) cerr << "SignalPinkNoiseRange: i1=%d, i2=%d" << endl;
}

void SignalPinkNoiseRange::shapeNoiseSpectrum
(
    double* sdata, 
    unsigned int num
)
{
    // sr stretches from 0 .. num
    // we must map i1 for f1 and i2 for f2:
    i1 = (unsigned int)((double)num * f1 / sr); 
    i2 = (unsigned int)((double)num * f2 / sr); 
    SignalColoredNoise::shapeNoiseSpectrum(sdata, num);
}

double SignalPinkNoiseRange::getRealFactor(unsigned int i)
{
    if (i < i1) return 0;
    if (i > i2) return 0;
    return 1.0 / sqrt((double)(i+1));
}


double SignalPinkNoiseRange::getImagFactor(unsigned int i)
{
    if (i < i1) return 0;
    if (i > i2) return 0;
    return 1.0 / sqrt((double)(i+1));
}

// --- end of file ---












