//---------------------------------------------------------------------------
// Copyright 2000 Andreas Huennebeck
//
// Licensed under the terms of the GNU General Public License.
// ABSOLUTELY NO WARRANTY. See the file 'COPYING' in this distribution.
//
// $Source: /home/ah/CvsTree/daten/src/gensig/SigSaw.c,v $
// $Id: SigSaw.c,v 1.1 2002/12/17 21:17:18 ah Exp $ 
//
// Description: print information about specified wav file
//
//---------------------------------------------------------------------------

const char sweep_CVSID[] = "$Id: SigSaw.c,v 1.1 2002/12/17 21:17:18 ah Exp $ (c) 2002 Andreas Huennebeck";

// --- necessary includes ---
#include <AH/Config/Platform.h> // always the first include
USING_NAMESPACE(AH)
#include "SigSaw.h"

#include <math.h>
USING_NAMESPACE(std)

#include <AH/Error/Sys.h>
#include <AH/Error/Intern.h>
USING_NAMESPACE(AH)


// --- local constants ---

// --- local data ---

// --- local classes ---

// --- local functions ---

// --- global functions ---

void SignalSaw::addSignal
(
    double* data,
    unsigned int num
)
{
    if (!data) throw ErrorInternNullPtrArg("SignalSaw::addSignal");
    if (!num) throw ErrorInternBadArg("SignalSaw::addSignal");

    const unsigned int tau = (unsigned int)(sr / freq);

    //--------------------------------------------------
    // x = i % tau   ==> 0 .. tau-1
    // y = a*x + b  y(0)= maxAmpl y(tau-1) = -maxAmpl
    // ==> maxAmpl = b
    //     -maxAmpl = a * (tau-1) + maxAmpl
    // ==> a = - 2 * maxAmpl / (tau - 1);
    //--------------------------------------------------
    double a = -2.0 * (double)maxAmpl / (double)(tau-1);
    for (unsigned int i = 0; i < num; ++i)
    {
	data[i] += a * (double)(i % tau) + (double)maxAmpl;
    }
}

// --- end of file ---











