//---------------------------------------------------------------------------
// Copyright 2000 Andreas Huennebeck
//
// Licensed under the terms of the GNU General Public License.
// ABSOLUTELY NO WARRANTY. See the file 'COPYING' in this distribution.
//
// $Source: /home/ah/CvsTree/daten/src/gensig/SigSquare.c,v $
// $Id: SigSquare.c,v 1.1 2002/12/08 19:58:48 ah Exp $ 
//
// Description: print information about specified wav file
//
//---------------------------------------------------------------------------

const char sweep_CVSID[] = "$Id: SigSquare.c,v 1.1 2002/12/08 19:58:48 ah Exp $ (c) 2002 Andreas Huennebeck";

// --- necessary includes ---
#include <AH/Config/Platform.h> // always the first include
USING_NAMESPACE(AH)
#include "SigSquare.h"

#include <math.h>
USING_NAMESPACE(std)

#include <AH/Error/Sys.h>
#include <AH/Error/Intern.h>
USING_NAMESPACE(AH)


// --- local constants ---

// --- local data ---

// --- local classes ---

// --- local functions ---

// --- global functions ---

void SignalSquare::addSignal
(
    double* data,
    unsigned int num
)
{
    if (!data) throw ErrorInternNullPtrArg("SignalSquare::addSignal");
    if (!num) throw ErrorInternBadArg("SignalSquare::addSignal");

    const unsigned int delta = (unsigned int)(sr / freq);
    for (unsigned int i = 0; i < num; ++i)
    {
	if ((i % delta) < delta/2) data[i] += maxAmpl;
	else                       data[i] -= maxAmpl;
    }
}

// --- end of file ---











