//---------------------------------------------------------------------------
// Copyright 2000 Andreas Huennebeck
//
// Licensed under the terms of the GNU General Public License.
// ABSOLUTELY NO WARRANTY. See the file 'COPYING' in this distribution.
//
// $Source: /home/ah/CvsTree/daten/src/gensig/SigWhiteNoiseRange.c,v $
// $Id: SigWhiteNoiseRange.c,v 1.2 2003/04/05 16:21:22 ah Exp $ 
//
// Description: print information about specified wav file
//
//---------------------------------------------------------------------------

const char sweep_CVSID[] = "$Id: SigWhiteNoiseRange.c,v 1.2 2003/04/05 16:21:22 ah Exp $ (c) 2002 Andreas Huennebeck";

// --- necessary includes ---
#include <AH/Config/Platform.h> // always the first include
USING_NAMESPACE(AH)
#include "SigWhiteNoiseRange.h"

#include <math.h>
#include <drfftw.h> 
USING_NAMESPACE(std)

#include <AH/Etech/Types.h> // always the first include
#include <AH/Error/Sys.h>
#include <AH/Error/Intern.h>
#include <AH/Math/Ft/Wisdom.h>
USING_NAMESPACE(AH)

#include "SigWhiteNoise.h"
#include "Util.h"

// --- local constants ---

// --- local data ---

// --- local classes ---

// --- local functions ---

// --- global functions ---

SignalWhiteNoiseRange::SignalWhiteNoiseRange
(
    double fbegin, double fend, double amplitude,
    unsigned int samplerate, unsigned int debug
)
    : SignalColoredNoise(amplitude, samplerate, debug),
      f1(fbegin), f2(fend)
{
    if (debon > 1) cerr << "SignalWhiteNoiseRange: f1=" << f1 << ", f2=" 
			<< f2  << endl;
}

void SignalWhiteNoiseRange::shapeNoiseSpectrum
(
    double* sdata, 
    unsigned int num
)
{
    // sr stretches from 0 .. num
    // we must map i1 for f1 and i2 for f2:
    i1 = (unsigned int)((double)num * f1 / sr); 
    i2 = (unsigned int)((double)num * f2 / sr); 
    SignalColoredNoise::shapeNoiseSpectrum(sdata, num);
}

double SignalWhiteNoiseRange::getRealFactor(unsigned int i)
{
    if (i < i1) return 0;
    if (i > i2) return 0;
    return 1;
}


double SignalWhiteNoiseRange::getImagFactor(unsigned int i)
{
    if (i < i1) return 0;
    if (i > i2) return 0;
    return 1;
}

// --- end of file ---












