//---------------------------------------------------------------------------
// Copyright 2002 Andreas Huennebeck
//
// Licensed under the terms of the GNU General Public License.
// ABSOLUTELY NO WARRANTY. See the file 'COPYING' in this distribution.
//
// $Source: /home/ah/CvsTree/daten/src/gensig/SigWhiteNoiseRange.h,v $
// $Id: SigWhiteNoiseRange.h,v 1.1 2002/12/16 23:42:26 ah Exp $ 
//
// Description: print information about specified wav file
//
//---------------------------------------------------------------------------

#ifndef SIGNAL_WHITE_NOISE_RANGE_H
#define SIGNAL_WHITE_NOISE_RANGE_H

// --- necessary includes ---
#include <AH/Config/Platform.h> // always the first include
USING_NAMESPACE(AH)
#include "SigColNoise.h"

// --- forward declarations ---

// --- types and classes ---

class SignalWhiteNoiseRange: public SignalColoredNoise
{
 public:
    SignalWhiteNoiseRange(double fbegin, double fend, double amplitude,
			  unsigned int samplerate, unsigned int debug = 0);
    virtual ~SignalWhiteNoiseRange() {}

 protected:
    virtual void shapeNoiseSpectrum(double* sdata, unsigned int num);
    virtual double getRealFactor(unsigned int i);
    virtual double getImagFactor(unsigned int i);
 private:
    double f1; // start frequency
    double f2; // end frequency
    unsigned int i1; // begin of range (tmp in shapeNoiseSpectrum)
    unsigned int i2; // end of range (tmp in shapeNoiseSpectrum)
};

#endif // !SIGNAL_WHITE_NOISE_RANGE_H
// --- end of file ---
