//---------------------------------------------------------------------------
// Copyright 2000 Andreas Huennebeck
//
// Licensed under the terms of the GNU General Public License.
// ABSOLUTELY NO WARRANTY. See the file 'COPYING' in this distribution.
//
// $Source: /home/ah/CvsTree/daten/src/gensig/Util.c,v $
// $Id: Util.c,v 1.3 2004/02/27 23:09:00 ah Exp $ 
//
// Description: print information about specified wav file
//
//---------------------------------------------------------------------------

const char Util_CVSID[] = "$Id: Util.c,v 1.3 2004/02/27 23:09:00 ah Exp $ (c) 2002 Andreas Huennebeck";

// --- necessary includes ---
#include <AH/Config/Platform.h> // always the first include
USING_NAMESPACE(AH)
#include "Util.h"

#include <math.h>
USING_NAMESPACE(std)

#include <AH/Error/Basic.h>
#include <AH/STL/String.h>
USING_NAMESPACE(AH)

// --- local constants ---

// --- local data ---

// --- local classes ---

// --- local functions ---

// --- global functions ---

double Util::getAmplitude(const std::string& arg, double maxAmp)
{
    //------------------------------------------
    // parse the argument: cut at white space
    //------------------------------------------
    std::vector<std::string> token;
    STLStringToken(arg, token);
    for (unsigned int i = 0; i < token.size(); ++i)
	STLStringDelSurround(token[i]);

    // parse the amplitude type:
    switch (token.size())
    {
    default:
    case 0: throw ErrorBasic(arg + ": illegal amplitude");
    case 1: 
	maxAmp = atof(token[0].c_str());
	if (maxAmp <= 0)
	    throw ErrorBasic(arg + ": illegal amplitude (missing blank?)");
	return maxAmp;
    case 2: // expected "num dB"
	if (0 != strcasecmp(token[1].c_str(), "db"))
	    throw ErrorBasic(arg + ": illegal amplitude unit");
	return (maxAmp * pow(10, atof(token[0].c_str())/20.0));
    }
    return 0; // to keep gcc quiet
}


void Util::normalize(double* data, unsigned int num, double norm_ampl)
{
    double max = 0;
    for (unsigned int i = 0; i < num; ++i)
    {
	double cur = fabs(data[i]);
	if (cur > max) max = cur;
    }
    if (max > 0) 
    {
	double corr = fabs(norm_ampl) / max;
	for (unsigned int i = 0; i < num; ++i)
	{
	    data[i] *= corr;
	}
    }
}


// --- end of file ---
