//---------------------------------------------------------------------------
// Copyright 2002 Andreas Huennebeck
//
// Licensed under the terms of the GNU General Public License.
// ABSOLUTELY NO WARRANTY. See the file 'COPYING' in this distribution.
//
// $Source: /home/ah/CvsTree/daten/src/ft/sweep.h,v $
// $Id: sweep.h,v 1.1 2002/11/01 18:16:38 ah Exp $ 
//
// Description: print information about specified wav file
//
//---------------------------------------------------------------------------

#ifndef SWEEP_H
#define SWEEP_H

// --- necessary includes ---
#include <AH/Config/Platform.h> // always the first include
USING_NAMESPACE(AH)

// --- forward declarations ---

class Cplx;

// --- types and classes ---

class SweepSpectrum
{
 public:
    SweepSpectrum(unsigned int num, double f1, double f2, double dur,
		  bool lin = false, unsigned int debug = 0);
    ~SweepSpectrum();

    const Cplx& getPoint(unsigned int num) const;

 private:
    void calculate();
    void makeSweep(double* sweep);

    static const double rate = 44100;

    unsigned int isize;
    unsigned int dsize;
    double begin;
    double end;
    double duration;
    bool option_linear;
    unsigned int debon;
    Cplx* data;
};

#endif // !SWEEP_H
// --- end of file ---
