//---------------------------------------------------------------------------
// Copyright 1997 Andreas Huennebeck
//
// $Source: /home/ah/CvsTree/daten/src/include/AH/Error/Class.h,v $
// $Id: Class.h,v 1.5 2004/03/15 20:58:47 ah Exp $
//
// Description: utility functions for working with string(STL) objects.
//
//---------------------------------------------------------------------------

#ifndef AH_ERROR_CLASS_H		// prevent multiple includes
#define AH_ERROR_CLASS_H

// --- forward declarations ---

// --- necessary includes ---

#include <AH/Config/Platform.h>
#include <string>
#include <exception>

USING_NAMESPACE(std)

// --- types and classes ---

BEGIN_NAMESPACE(AH)


/**
   ErrorClass is the virtual base class of all error classes.

   Please include <Error/Class.h>.
*/
/// interface definition to all error classes
    class ErrorClass: public exception
{
  public:
    /// constructor
    ErrorClass () {}
    /// destructor
    virtual ~ErrorClass () throw() {}
    
    // access functions:
    /// return error message
    /**
       All derived classes must implement getMsg() to be able
       to use the overloaded ostream operator for output
    */
    virtual string getMsg() const = 0;
    virtual const char* what() { return getMsg().c_str(); }
}; // end of class ErrorClass


END_NAMESPACE

#endif // AH_ERROR_CLASS_H
//**********************************************************************
//*			     E N D   O F   F I L E                     *
//**********************************************************************







