//---------------------------------------------------------------------------
// Copyright 1997 Andreas Huennebeck
//
// $Source: /home/ah/CvsTree/daten/src/include/AH/Etech/BPT.h,v $
// $Id: BPT.h,v 1.4 2001/10/05 23:44:27 ah Exp $
//
//---------------------------------------------------------------------------

#ifndef ETECH_BPT_H	// prevent multiple includes
#define ETECH_BPT_H

// --- necessary includes ---

#include <AH/Config/Platform.h>
#include <AH/Etech/Transistor.h>
#include <AH/Etech/Voltage.h>

USING_NAMESPACE(Ah)

// --- types and classes ---

BEGIN_NAMESPACE(Ah)

/// represents a bipolar transistor
/**
 {\tt BPT} represents a bipolar transistor. It can be used both 
 in DC (direct current) and in AC (alternate current) applications.
 */
class BPT: public Transistor
{
  protected:
    static const Current Ics;		// Sperrstrom fuer Silizium
  
  public:
    /// default constructor
    BPT() {}

    /// destructor
    virtual ~BPT() {}

    /// get steilheit
    virtual Cplx getS(const Voltage& Ube, Dbl t = PhysConst_T25) const;
//    virtual Cplx getS(const Voltage& Ube, Dbl t = PhysConst::t25) const;
    /// get steilheit
    virtual Cplx getS(const Current& Ic, Dbl t = PhysConst_T25) const;
//    virtual Cplx getS(const Current& Ic, Dbl t = PhysConst::t25) const;

    /// return output current depending on input voltage
    virtual Current getIout(const Voltage& Uin, 
			    Dbl t = PhysConst_T25) const;
//			    Dbl t = PhysConst::t25) const;

    /// get Ut at specified temperature
    static Voltage getUt(Dbl t = PhysConst_T25);
//    static Voltage getUt(Dbl t = PhysConst::t25);

}; // class BPT


END_NAMESPACE

#endif // ETECH_BPT_H
