//---------------------------------------------------------------------------
// Copyright 1998 Andreas Huennebeck
//
// $Source: /home/ah/CvsTree/daten/src/include/AH/Etech/MonacorSpeakers.h,v $
// $Id: MonacorSpeakers.h,v 1.5 2001/10/05 23:44:27 ah Exp $
//
//---------------------------------------------------------------------------

#ifndef ETECH_MONACOR_SPEAKERS_H	// prevent multiple includes
#define ETECH_MONACOR_SPEAKERS_H

// --- necessary includes ---

#include <AH/Config/Platform.h>
#include <AH/Etech/Speaker.h>

USING_NAMESPACE(Ah)
BEGIN_NAMESPACE(Ah)

// --- forward declarations ---

class IntPol;

// --- types and classes ---


/// represents the speaker Monacor SP-45/4
/**
 {\tt Monacor\_SP45\_4} represents the small bass/midrange speaker SP-45 in
 4 Ohm version which is made by Monacor.
 */
class Monacor_SP45_4: public Speaker
{
  public:
    /// default constructor
    Monacor_SP45_4();

    /// destructor
    virtual ~Monacor_SP45_4() {}
};


/// represents the speaker Monacor SP-45/8
/**
 {\tt Monacor\_SP45\_8} represents the small bass/midrange speaker SP-45 in
 8 Ohm version which is made by Monacor.
 */
class Monacor_SP45_8: public Speaker
{
  public:
    /// default constructor
    Monacor_SP45_8();

    /// destructor
    virtual ~Monacor_SP45_8() {}
};


/// represents the speaker Monacor SP-60/4
/**
 {\tt Monacor\_SP60\_4} represents the small bass/midrange speaker SP-60 in
 4 Ohm version which is made by Monacor.
 */
class Monacor_SP60_4: public Speaker
{
  public:
    /// default constructor
    Monacor_SP60_4();

    /// destructor
    virtual ~Monacor_SP60_4() {}
};


/// represents the speaker Monacor SP-60/8
/**
 {\tt Monacor\_SP60\_8} represents the small bass/midrange speaker SP-60 in
 8 Ohm version which is made by Monacor.
 */
class Monacor_SP60_8: public Speaker
{
  public:
    /// default constructor
    Monacor_SP60_8();

    /// destructor
    virtual ~Monacor_SP60_8() {}
};


/// represents the speaker Monacor SPP-110/4
/**
 {\tt Monacor\_SPP110\_4} represents the small bass/midrange speaker SP-110 in
 4 Ohm version which is made by Monacor.
 */
class Monacor_SPP110_4: public Speaker
{
  public:
    /// default constructor
    Monacor_SPP110_4();

    /// destructor
    virtual ~Monacor_SPP110_4() {}
};


/// represents the speaker Monacor SPP-110/8
/**
 {\tt Monacor\_SPP110\_8} represents the small bass/midrange speaker SP-110 in
 8 Ohm version which is made by Monacor.
 */
class Monacor_SPP110_8: public Speaker
{
  private:
    static IntPol* splCurve;

  public:
    /// default constructor
    Monacor_SPP110_8();

    /// destructor
    virtual ~Monacor_SPP110_8() {}

    /// get acoustic power level dB/W/m at specified frequency
    virtual Dbl getSpl(Dbl freq) const;
};


END_NAMESPACE

#endif // ETECH_MONACOR_SPEAKERS_H
