//---------------------------------------------------------------------------
// Copyright 2002 Andreas Huennebeck
//
// Licensed under the terms of the GNU General Public License.
// ABSOLUTELY NO WARRANTY. See the file 'COPYING' in this distribution.
//
// $Source: /home/ah/CvsTree/daten/src/include/AH/Math/Ft/Wisdom.h,v $
// $Id: Wisdom.h,v 1.1 2002/12/17 22:48:07 ah Exp $ 
//
// Description: 
//
//---------------------------------------------------------------------------

#ifndef AH_MATH_FT_WISDOM_H
#define AH_MATH_FT_WISDOM_H

// --- necessary includes ---

#include <string>
#include <vector>
#include <drfftw.h>

// --- types and classes ---

class MathFtWisdom
{
 public:
    MathFtWisdom(unsigned int debug = 0);
    virtual ~MathFtWisdom();

    rfftw_plan getPlan(unsigned int num, 
		       fftw_direction direction = FFTW_FORWARD);

 private:
    void importFromFile();
    void exportToFile();

    struct Entry
    {
	rfftw_plan plan;
	unsigned int size;
	fftw_direction dir;
    };
    std::string fileName;
    std::vector<Entry> table;
    unsigned int debon;
};

#endif // !AH_MATH_FT_WISDOM_H
// --- end of file ---
