//---------------------------------------------------------------------------
// Copyright 1997 Andreas Huennebeck
//
// $Source: /home/ah/CvsTree/daten/src/include/AH/Math/RegulaFalsi.h,v $
// $Id: RegulaFalsi.h,v 1.3 2002/12/07 02:39:34 ah Exp $
//
//---------------------------------------------------------------------------

#ifndef MATH_REGULAFALSI_H	// prevent multiple includes
#define MATH_REGULAFALSI_H

// --- necessary includes ---

#include <AH/Math/NullSearch.h>

USING_NAMESPACE(Ah)

// --- types and classes ---

BEGIN_NAMESPACE(Ah)

/// represents a regula falsi search class for zero crossing points
/**
 {\tt RegulaFalsi} is a zero crossing search base class, which uses
 the {\em Regula Falsi} algorithm.
 */
class RegulaFalsi: public NullSearch
{
  public:
    RegulaFalsi(double (*searchFunc)(double))
	: NullSearch(searchFunc) {}

    /// search the zero crossing point
    virtual double search
    (
	double lowLim,
	double hiLim,
	double eps
    );
}; // class RegulaFalsi


// --- function prototypes ---

END_NAMESPACE

#endif // MATH_REGULAFALSI_H













