//---------------------------------------------------------------------------
// Copyright 1998 Andreas Huennebeck
//
// $Source: /home/ah/CvsTree/daten/src/libAHetech/Impedance.c,v $
// $Id: Impedance.c,v 1.6 2001/10/05 23:44:26 ah Exp $
//
// Description: implementation of class Impedance
//
//---------------------------------------------------------------------------

static const char rcsid[] = "$Id: Impedance.c,v 1.6 2001/10/05 23:44:26 ah Exp $ (c) 1998 Andreas Huennebeck";

// --- necessary includes ---

#include <AH/Config/Platform.h>
#include <AH/Etech/Impedance.h>

USING_NAMESPACE(Ah)

BEGIN_NAMESPACE(Ah)

// --- local stuff ---

// --- class member implementation ---

// --- overloaded operators ---

//------------------------
// operators for addition:
//------------------------

// overloaded operator || for parallel circuit of two impedances
Impedance operator || (const Impedance &z1, const Impedance &z2)
{
    if (z1.isInf()) return z2;	// || infinity : ignore
    if (z2.isInf()) return z1;	// || infinity : ignore
    if (z1.isNul()) return 0;	// || 0 = 0
    if (z2.isNul()) return 0;	// || 0 = 0
    return Impedance(z1.Value * z2.Value / (z1.Value + z2.Value)); 
}


//---------------------------
// operators for subtraction:
//---------------------------

//------------------------------
// operators for multiplication:
//------------------------------

//------------------------
// operators for division:
//------------------------

// --- friend functions ---

END_NAMESPACE
