//---------------------------------------------------------------------------
// Copyright 1997 Andreas Huennebeck
//
// $Source: /home/ah/CvsTree/daten/src/libAHetech/Riaa.c,v $
// $Id: Riaa.c,v 1.7 2001/10/05 23:44:26 ah Exp $
//
// Description: implementation of RIAA de/emphasis calculation
//
//---------------------------------------------------------------------------

static const char rcsid[] = "$Id: Riaa.c,v 1.7 2001/10/05 23:44:26 ah Exp $ (c) 1997 Andreas Huennebeck";

// --- necessary includes ---

#include <AH/Config/Platform.h>
#include <AH/Etech/Riaa.h>
#include <AH/Etech/MathConst.h>

USING_NAMESPACE(Ah)
BEGIN_NAMESPACE(Ah)

// --- local stuff ---

// --- global function implementation ---

Cplx RiaaDeEmphasis(Dbl f)
{
    Dbl t1(3180e-6);
    Dbl t2(318e-6);
    Dbl t3(75e-6);

    Cplx n1(1, 2 * MathConst::Pi * f * t1);
    Cplx n2(1, 2 * MathConst::Pi * f * t3);
    Cplx z (1, 2 * MathConst::Pi * f * t2);
    Cplx Ua2Ue = z / (n1 * n2);

    return (Ua2Ue);
}


Cplx RiaaPreEmphasis(Dbl f)
{
    Dbl t1(3180e-6);
    Dbl t2(318e-6);
    Dbl t3(75e-6);

    Cplx n1(1, 2 * MathConst::Pi * f * t1);
    Cplx n2(1, 2 * MathConst::Pi * f * t3);
    Cplx z (1, 2 * MathConst::Pi * f * t2);
    Cplx Ua2Ue = (n1 * n2) / z;

    return (Ua2Ue);
}


END_NAMESPACE
