//---------------------------------------------------------------------------
// Copyright 1999 Andreas Huennebeck
//
// $Source: /home/ah/CvsTree/daten/src/libAHio/TestDir.c,v $
// $Id: TestDir.c,v 1.2 2004/04/20 22:26:22 ah Exp $
//
// Description: 
//
//---------------------------------------------------------------------------

static const char rcsid[] = "$Id: TestDir.c,v 1.2 2004/04/20 22:26:22 ah Exp $ (c) 1999 Andreas Huennebeck";

// --- necessary includes ---

#include <AH/IO/Dir.h>		// my interface first, says Lakos
USING_NAMESPACE(AH)

#include <cstdio>
#include <unistd.h>
#include <string>
#include <cerrno>
#include <iostream>
USING_NAMESPACE(std)


static unsigned int execute_test (const char* path, bool verbose)
{
    if (!path)
    {
	cerr << "Internal Error (null pointer arg)" << endl;
	return 1;
    }

    cout << "- Listing of " << path << ": ";
    vector<string> list;
    int ret = IODir::getList(string(path), list);
    if (-1 == ret)
    {
	cerr << "Error " << errno << ": " << strerror(errno) << endl;
	return 1;
    }

    cout << list.size() << " entries" << endl;
    if (verbose)
    {
	for (unsigned int i=0; i < list.size(); i++)
	{
	    cout << "\t" << list[i] << endl;
	}
	cout << endl;
    }

    return 0;
}


int main(int argc, char* argv[])
{
    cerr << "Test of " << argv[0] << ":" << endl;

    // set default options:
    static char* cmdLineOptions = "v";

    // loop through command line options:
    int option;
    bool verbose = false;
    while ((option = getopt(argc, argv, cmdLineOptions)) != -1)
    {
	switch (option) 
	{
	case 'v': verbose = true;			break;

	case '?': /* fall through */
	default : exit(1);				break;
	}
    }

    unsigned int errnum = 0;
    errnum += execute_test("/", verbose);
    errnum += execute_test(".", verbose);
    errnum += execute_test("..", verbose);

    for (int i=optind; i < argc; i++)
    {
	errnum += execute_test(argv[i], verbose);
    }

    // print test results:
    cerr << argv[0] << ": ";
    if (errnum)
    {
	cerr << "failed with " << errnum << " error"
	     << (errnum > 1 ? "s" : "") << ". stop." << endl;
	return 1;;
    }
    cerr << "passed." << endl;
    return 0;
}













