/*
 *******************************************************************
 *
 * $Source: /bscl/CvsTree/bscl/gen/src/lib/libcb/localswap2.c,v $
 *
 * Copyright (c) 1995
 * BRUKER ANALYTISCHE MESSTECHNIK GMBH
 * D-76287 Rheinstetten, Germany
 *
 * All Rights Reserved
 *
 *
 * $Locker:  $
 * $State: Exp $
 * $Log: localswap2.c,v $
 * Revision 1.2  1995/12/21 16:24:46  ah
 * removed warnings caused by AllCWarnFlags.
 *
 * Revision 1.1  1995/07/12 15:03:35  ah
 * Initial revision
 *
 *
 *******************************************************************
 *	local_swap2() -	2 byte swap of memory content
 *			if parameter endian differs from local endian
 *			parameter endian set to 2 forces swap
 *
 *	Library:	/bscl/lib/libcb.a
 *	Source:		/bscl/src/lib/libcb/localswap2.c
 *	Documentation:	/bscl/docu/lib/libcb/localswap2.tex
 *
 *	Return Values:	none
 *
 *	Error Message:	none
 *******************************************************************
 */

#include <lib/libcb.h>

static const char rcsid[] = "$Header: /bscl/CvsTree/bscl/gen/src/lib/libcb/localswap2.c,v 1.2 1995/12/21 16:24:46 ah Exp $ (C) 1995 Bruker Analyt. Messt.";


/****************************************************************/
void local_swap2
(
  register void* ibuf,			/* buffer start address	*/
  const int  size,			/* buffer size in bytes	*/
  const int  endian			/* remote endian	*/
)
/****************************************************************/
{
    if( local_endian() != endian )
    {
	register char* buf = ibuf;
	register char* ebuf = buf + size; /* buffer end address */

	while ( buf < ebuf )
	{
	    register char c = buf[0];
	    buf[0] = buf[1];
	    buf[1] = c;
	    buf   += 2;
	}
    }
}

