//---------------------------------------------------------------------------
// Copyright 1997 Andreas Huennebeck
//
// Licensed under the terms of the GNU General Public License.
// ABSOLUTELY NO WARRANTY. See the file `COPYING' in this distribution.
//
// $Source: /home/ah/CvsTree/daten/src/libAHstl/Token.c,v $
// $Id: 
//
// Description: 
//
//---------------------------------------------------------------------------

static const char cvsid[] = "$Id: Token.c,v 1.4 2003/03/18 01:00:14 ah Exp $ (c) 1997 Andreas Huennebeck";

// --- necessary includes ---

#include <AH/STL/String.h>
USING_NAMESPACE(AH)

BEGIN_NAMESPACE(AH)

void STLStringToken
(
    /// string to extract tokens from
    const string& line,		
    /// sequential string container
    vector<string>& result,
    /// token separator characters (default is white space)
    const char* separator
)
{
    string::size_type start = line.find_first_not_of(separator);
    if (string::npos == start) return;	// nothing found

    do
    {
	string::size_type end = line.find_first_of(separator,start);
	if (string::npos == end)
	{
	    result.push_back(line.substr(start));
	    start = string::npos;	// finish loop
	}
	else
	{
	    result.push_back(line.substr(start, end - start));
	    start = line.find_first_not_of(separator, end);
	}
    }
    while (string::npos != start);
}


END_NAMESPACE





