//---------------------------------------------------------------------------
// Copyright 2005 Andreas Huennebeck
//
// Licensed under the terms of the GNU General Public License.
// ABSOLUTELY NO WARRANTY. See the file 'COPYING' in this distribution.
//
// $Source: /home/ah/CvsTree/daten/src/wavtool/reduce.h,v $
// $Id: reduce.h,v 1.1 2005/01/16 20:22:01 ah Exp $ 
//
// Description: reduce spectral data
//
//---------------------------------------------------------------------------

// --- necessary includes ---
#include <AH/Config/Platform.h> // always the first include
USING_NAMESPACE(AH)

BEGIN_NAMESPACE(AH)

class ReduceFFTW
{
 public:
    ReduceFFTW(int v) 
	: verbose(v) {}

    void processLinXScale(fftw_real* data, unsigned int insize, 
			  double* avout, double* pkout, unsigned int outsize,
			  double f_max, double f1, double f2);
    void processLogXScale(fftw_real* data, unsigned int insize, 
			  double* avout, double* pkout, unsigned int outsize,
			  double f_max, double f1, double f2, double smooth);
 private:
    void smoothLogXScale(double* data, unsigned int insize, 
			 unsigned int outsize, double smooth,
			 double f1, double f2);
    int verbose;
};

END_NAMESPACE

// --- end of file ---
